//
//  MapViewAnnotationController.m
//  MBMapDemo
//
//  Created by 张嘉伟 on 11-10-12.
//  Copyright (c) 2011年 __MyCompanyName__. All rights reserved.
//

#import "MapViewAnnotationController.h"

@implementation MapViewAnnotationController

-(id)initWithMapView:(MapView *)theMapView
{
    self = [super initWithMapView:theMapView];
    if (self) {
        
    }
    return self;
}

-(void)dealloc
{
    [_myAnnotation dealloc];
    [_addOrRemoveButton dealloc];
    [super dealloc];
}
-(void)viewDidLoad
{
    [super viewDidLoad];
    
    _addOrRemoveButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    _addOrRemoveButton.frame = CGRectMake(10, 50, 70, 30);
    [_addOrRemoveButton setTitle:@"添加标注" forState:UIControlStateNormal];
    [_addOrRemoveButton addTarget:self action:@selector(addOrRemove:)  forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_addOrRemoveButton];
    
    MapView *myMapView = self.mapView;
    
    myMapView.delegate = self;
    
    _myAnnotation = [[MyCustomAnnotation alloc]initWithLocation:CLLocationCoordinate2DMake(39.908716, 116.397400)];
    _myAnnotation.title = @"天安门";
    [myMapView addAnnotation:_myAnnotation];
    [myMapView setCenterCoordinate:_myAnnotation.coordinate];
    _added = YES;
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];

    self.mapView.delegate = self;
    _addOrRemoveButton.hidden = NO;
}
-(void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];

    self.mapView.delegate = nil;
    _addOrRemoveButton.hidden = YES;
}

-(void)addOrRemove:(id)sender
{
    MapView *myMapView = self.mapView;
    if (_added) {
        [myMapView removeAnnotation:_myAnnotation];
        [_addOrRemoveButton setTitle:@"添加标注" forState:UIControlStateNormal];
        _added = NO;
    }
    else
    {
        [myMapView addAnnotation:_myAnnotation];
        [_addOrRemoveButton setTitle:@"移除标注" forState:UIControlStateNormal];
        _added = YES;
    }   
}
- (MBAnnotationView *)mapView:(MBMapView *)mapView viewForAnnotation:(id <MBAnnotation>)annotation
{
    if ([annotation isKindOfClass:[MyCustomAnnotation class]]) {
        MBAnnotationView* aView = [[[MBAnnotationView alloc] initWithAnnotation:annotation
                                                                reuseIdentifier:@"MyCustomAnnotation"] autorelease];
        aView.image = [UIImage imageNamed:@"poi.png"];
        return aView;
    }
    return nil;
}

@end
