//
//  MapViewCircleController.m
//  MBMapDemo
//
//  Created by 张嘉伟 on 11-10-12.
//  Copyright (c) 2011年 __MyCompanyName__. All rights reserved.
//

#import "MapViewCircleController.h"

@implementation MapViewCircleController

-(id)initWithMapView:(MapView *)theMapView
{
    self = [super initWithMapView:theMapView];
    if (self) {
       
    }
    return self;
}

-(void)dealloc
{
    [_addOrRemoveButton release];
    [_myCircle release];
    [super dealloc];
}
-(void)viewDidLoad
{
    [super viewDidLoad];
    
    _addOrRemoveButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    _addOrRemoveButton.frame = CGRectMake(10, 50, 70, 30);
    [_addOrRemoveButton setTitle:@"绘制圆形" forState:UIControlStateNormal];
    [_addOrRemoveButton addTarget:self action:@selector(addOrRemove:)  forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_addOrRemoveButton];
    
    //clear map
    MapView *myMapView = self.mapView;
    
    myMapView.delegate = self;
    CLLocationCoordinate2D coords[] = {{39.908716,116.397400},{39.90809,116.411369}};
    _myCircle = [[MBCircle circleWithCenterCoordinate:coords[0] radius:200] retain];
    //[myMapView addOverlay:_myCircle];
    _added = NO;
    [myMapView setCenterCoordinate:CLLocationCoordinate2DMake(39.908716,116.397400)];
    
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];

    self.mapView.delegate = self;
    _addOrRemoveButton.hidden = NO;
}
-(void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];

    self.mapView.delegate = nil;
    _addOrRemoveButton.hidden = YES;
}

-(void)addOrRemove:(id)sender
{
    MapView *myMapView = self.mapView;
    if (_added) {
        [myMapView removeOverlay:_myCircle];
        [_addOrRemoveButton setTitle:@"添加圆形" forState:UIControlStateNormal];
        _added = NO;
    }
    else
    {
        [myMapView addOverlay:_myCircle];
        [_addOrRemoveButton setTitle:@"移除圆形" forState:UIControlStateNormal];
        _added = YES;
    }   
}
- (MBOverlayView *)mapView:(MBMapView *)mapView viewForOverlay:(id<MBOverlay>)overlay
{ 
    if ([overlay isKindOfClass:[MBCircle class]]) {
        MBCircleView *circleView = [[MBCircleView alloc] initWithCircle:overlay];
        circleView.lineWidth = 15.0;
        circleView.strokeColor = [UIColor colorWithRed:204/255 green:153/255 blue:255/255 alpha:1.0];
        circleView.fillColor = [UIColor colorWithWhite:0.5 alpha:0.3];
        return circleView;
    }
    return nil;
}

@end
