//
//  MapViewZoomController.m
//  MBMapDemo
//
//  Created by 张嘉伟 on 11-10-12.
//  Copyright (c) 2011年 __MyCompanyName__. All rights reserved.
//

#import "MapViewZoomController.h"

@implementation MapViewZoomController


-(void)viewDidLoad
{
    [super viewDidLoad];

    //clear map
    _zoomInButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    _zoomInButton.frame = CGRectMake(10, 50, 50, 30);
    [_zoomInButton setTitle:@"缩小" forState:UIControlStateNormal];
    [_zoomInButton addTarget:self action:@selector(zoomIn)  forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_zoomInButton];
    
    _zoomOutButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    _zoomOutButton.frame = CGRectMake(10, 100, 50, 30);
    [_zoomOutButton setTitle:@"放大" forState:UIControlStateNormal];
    [_zoomOutButton addTarget:self action:@selector(zoomOut)  forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_zoomOutButton];
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];

    _zoomOutButton.hidden = NO;
    _zoomInButton.hidden = NO;
}

-(void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];

    _zoomOutButton.hidden = YES;
    _zoomInButton.hidden = YES;
}

-(void)dealloc
{
    [_zoomInButton dealloc];
    [_zoomOutButton dealloc];
    [super dealloc];
}
-(void)zoomIn
{
    MapView *myMapView = self.mapView;
    
    MBCoordinateRegion theRegion = myMapView.region;
    
    // Zoom out
    theRegion.span.longitudeDelta *= 2.0;
    theRegion.span.latitudeDelta *= 2.0;
    [myMapView setRegion:theRegion animated:YES];
}

-(void)zoomOut
{
    MapView *myMapView = self.mapView;
    
    MBCoordinateRegion theRegion = myMapView.region;
    
    // Zoom out
    theRegion.span.longitudeDelta /= 2.0;
    theRegion.span.latitudeDelta /= 2.0;
    [myMapView setRegion:theRegion animated:YES];
}


@end
