//
//  SearchViewController.m
//  MBMapDemo
//
//  Created by 张嘉伟 on 11-10-19.
//  Copyright (c) 2011年 __MyCompanyName__. All rights reserved.
//

#import "SearchViewController.h"
#import "MyCustomAnnotation.h"

@implementation SearchViewController

@synthesize barStyle, statusStyle, demoInfo ,functionBar;

- (id)init
{
    self = [super init];
    if (self) {
        // Custom initialization
        _suggests  = [[NSMutableArray alloc] init];
        _results = [[NSMutableArray alloc] init];
    }
    return self;
}

-(void)dealloc
{
    [_search release];
    [_suggests release];
    [_results release];
    [functionBar release];
    [functionSegment release];
    [originTextField release];
    [destinationTextField release];
    [_directionsView release];
    [searchDisplayController0 release];
    [searchDisplayController1 release];
    [searchDisplayController2 release];

    [super dealloc];
}
- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    _mapView = [MapView sharedMapView];
    _mapView.frame = CGRectMake(0, 0, 320, 460);
    self.view = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 320, 460)];;
    _mapView.delegate = self;
    
    _searchbar = [[UISearchBar alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 44.0)];
    _searchbar.tag = 100;
    _searchbar.delegate = self;
    _searchbar.autoresizesSubviews = YES;
    _searchbar.autoresizingMask = UIViewAutoresizingFlexibleWidth|UIViewAutoresizingFlexibleBottomMargin;
    _searchbar.scopeButtonTitles = [NSArray arrayWithObjects:@"POI",@"公交站点",@"公交路线",nil];
    _searchbar.showsScopeBar = YES;
    [self.view addSubview:_searchbar];
    
    searchDisplayController0 = [[UISearchDisplayController alloc] initWithSearchBar:_searchbar contentsController:self];
    [searchDisplayController0 setDelegate:self];  
    [searchDisplayController0 setSearchResultsDataSource:self];  
    [searchDisplayController0 setSearchResultsDelegate:self];
    
    functionBar = [[UIToolbar alloc]initWithFrame:CGRectMake(0, 372, 320, 44)];
    [self.view addSubview:functionBar];
    [functionBar release];
    functionSegment = [[UISegmentedControl alloc]initWithItems:[NSArray arrayWithObjects:@"搜索",@"路线", nil]];
    functionSegment.selectedSegmentIndex = 0;
    functionSegment.frame = CGRectMake(20, 7, 280, 30);
    functionSegment.segmentedControlStyle = UISegmentedControlStyleBar;
	[functionSegment addTarget:self action:@selector(chooseFunction:) forControlEvents:UIControlEventValueChanged]; 
    [functionBar addSubview:functionSegment];

    _directionsView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 320, 88)];
    _directionsView.backgroundColor = [UIColor blueColor];
    
    originTextField = [[UISearchBar alloc] initWithFrame:CGRectMake(0, 0, 320, 44)];
    originTextField.placeholder = @"起点";
    //originTextField.returnKeyType = UIReturnKeyNext;
    originTextField.showsCancelButton = NO;
    originTextField.tag = 101;
    originTextField.delegate = self;
    _searchbar.autoresizesSubviews = YES;

    searchDisplayController1 = [[UISearchDisplayController alloc] initWithSearchBar:originTextField contentsController:self];  
    [searchDisplayController1 setDelegate:self];  
    [searchDisplayController1 setSearchResultsDataSource:self];  
    [searchDisplayController1 setSearchResultsDelegate:self];
    
    destinationTextField = [[UISearchBar alloc] initWithFrame:CGRectMake(0, 44, 320, 44)];
    destinationTextField.placeholder = @"终点:";
    //destinationTextField.returnKeyType = UIReturnKeyRoute;
    destinationTextField.showsCancelButton = NO;
    destinationTextField.tag = 102;
    destinationTextField.delegate = self;

     searchDisplayController2 = [[UISearchDisplayController alloc] initWithSearchBar:destinationTextField contentsController:self];  
    [searchDisplayController2 setDelegate:self];  
    [searchDisplayController2 setSearchResultsDataSource:self];  
    [searchDisplayController2 setSearchResultsDelegate:self];
    [_directionsView addSubview:originTextField];
    [_directionsView addSubview:destinationTextField];
    
    _directionsView.hidden = YES;
    [self.view addSubview:_directionsView];

    _search = [[MBSearch alloc]init];
    _search.delegate = self;
}
-(void)chooseSearch
{
    self.title = @"搜索";
    _searchbar.hidden = NO;
    _directionsView.hidden = YES;

}
-(void)chooseDirections
{
    self.title = @"路线";
    _searchbar.hidden = YES;
    _directionsView.hidden = NO;

}
- (void)chooseFunction:(id)sender
{
	UISegmentedControl *segment = (UISegmentedControl *)sender;
	
	switch (segment.selectedSegmentIndex)
	{
		case 0:
			[self chooseSearch];
			break;
		case 1:
			[self chooseDirections];
			break;
		default:
			break;
	}
}

-(void)getSuggestKeywords:(NSString *)searchString
{
    NSString *city = @"北京市";
    [_search suggestKeyword:searchString inCity:city count:8];
}

-(void)getRouteSuggest:(NSString *)searchString
{
    NSString *city = @"北京市";
    [_search routeSuggetKeyword:searchString inCity:city pageNumber:1];
}

-(void)searchPoi:(NSString *)searchString
{
    NSString *city = @"北京市";
    _search.pageCount = 10;
    [_search PoisWithKeyword:searchString inCity:city pageNumber:1];
}

-(void)searchBusStation:(NSString *)searchString
{
    NSString *city = @"北京市";
    _search.pageCount = 10;
    [_search busStationsWithKeyword:searchString inCity:city pageNumber:1];
}

-(void)searchBusLine:(NSString *)searchString
{
    NSString *city = @"北京市";
    _search.pageCount = 10;
    [_search busLinesWithKeyword:searchString inCity:city pageNumber:1];
}

-(void)doSearch:(NSString *)searchString
{
    switch (_searchbar.selectedScopeButtonIndex) {
        case 0:
            [self searchPoi:searchString];
            break;
        case 1:
            [self searchBusStation:searchString];
            break;
        case 2:
            [self searchBusLine:searchString];
            break;
        default:
            break;
    }
}
-(void)searchDirectionsFromOrigin:(CLLocationCoordinate2D)theOrigin toDestination:(CLLocationCoordinate2D)theDestination
{
    [_search driveDirectionsFromOrigin:origin toDestination:destination option:MBDriveDirectionsOptionBestRoute];
}
- (void)viewDidUnload
{
    [super viewDidUnload];
}

- (void)viewWillAppear:(BOOL)animated
{
    [self.view insertSubview:_mapView atIndex:0];
    [self.view bringSubviewToFront:functionBar];
    _mapView.delegate = self;
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
    _mapView.delegate = nil;
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
    [_mapView removeAnnotations:_mapView.annotations];
    [_mapView removeOverlays:_mapView.overlays];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{ 
    return [_suggests count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) 
    {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle
                                       reuseIdentifier:CellIdentifier] autorelease];
    }
    
    id suggest = [_suggests objectAtIndex:indexPath.row];
    if ([suggest isKindOfClass:[MBRouteSuggest class]])
    {
        MBRouteSuggest *suggest = [_suggests objectAtIndex:indexPath.row];
        cell.textLabel.text = suggest.name;
        cell.detailTextLabel.text = [NSString stringWithFormat:@"%.6f,%.6f",suggest.coordinate.latitude, suggest.coordinate.longitude];
        cell.textLabel.textAlignment = UITextAlignmentLeft;
        cell.textLabel.textColor = [UIColor blackColor];
    }
    else if([suggest isKindOfClass:[MBSuggest class]])
    {
        MBSuggest *suggest = [_suggests objectAtIndex:indexPath.row];
        cell.textLabel.text = suggest.keyword;
        cell.detailTextLabel.text = suggest.district;
        cell.textLabel.textAlignment = UITextAlignmentLeft;
        cell.textLabel.textColor = [UIColor blackColor];
    }
    
    return cell;
}

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (tableView == searchDisplayController0.searchResultsTableView)
    {
        MBSuggest *suggest = [_suggests objectAtIndex:indexPath.row];
       
        [self doSearch:[suggest keyword]];
        searchDisplayController0.active = NO;
    }
    else if(tableView == searchDisplayController1.searchResultsTableView)
    {
        MBRouteSuggest *suggest = [_suggests objectAtIndex:indexPath.row];
        originTextField.text = [suggest name];
        origin = [suggest coordinate];
        searchDisplayController1.active = NO;

    }
    else if(tableView == searchDisplayController2.searchResultsTableView)
    {
        MBRouteSuggest *suggest = [_suggests objectAtIndex:indexPath.row];
        destinationTextField.text = [suggest name];
        destination = [suggest coordinate];
        searchDisplayController2.active = NO;

    }

}

#pragma mark - MBSearchDelegate
-(void)search:(MBSearch *)search didReceivedSuggestResult:(MBSuggestResult *)suggestResult
{
    [_suggests removeAllObjects];
    [_suggests setArray:suggestResult.suggests];
    [searchDisplayController0.searchResultsTableView reloadData];
}

-(void)search:(MBSearch *)search didReceivedRouteSuggestResult:(MBRouteSuggestResult *)routeSuggestResult
{
    [_suggests removeAllObjects];
    [_suggests setArray:routeSuggestResult.suggests];
    if ([originTextField isFirstResponder]) {
        [searchDisplayController1.searchResultsTableView reloadData];
    }
    else  if ([destinationTextField isFirstResponder]) {
        [searchDisplayController2.searchResultsTableView reloadData];
    }
}
-(void)search:(MBSearch *)search didReceivedBusStationDetailResult:(MBBusStationDetailResult *)busStationDetailResult
{
//    NSArray *lines = busStationDetailResult.lines;
//    for (MBBusStationDetail *stationDetail in lines) {
//        NSString *name = stationDetail.lineName;
//        NSUInteger type = stationDetail.lineType;
//        CLLocationCoordinate2D coordinate= stationDetail.coordinate;
//        NSString *more = stationDetail.searchString;
//    }
}

-(void)search:(MBSearch *)search didReceivedBusLineDetailResult:(MBBusLineDetailResult *)busLineDetailResult
{
//    NSString *instructions = busLineDetailResult.instructions;
//    NSUInteger numPoints = busLineDetailResult.numPoints;
//    NSArray *path = busLineDetailResult.path;
//    NSArray *stations = busLineDetailResult.stations;
//    for (MBBusStation *station in stations) {
//        NSString *name = station.name;
//        CLLocationCoordinate2D coordinate= station.coordinate;
//        NSString *more = station.searchString;
//    }
}
-(void)search:(MBSearch *)search didReceivedTransitRoute:(MBTransitRoute *)transitRoute
{
//    for(MBTransitStep *step in transitRoute.steps)
//    {
//        NSUInteger index = step.index;
//        NSUInteger numStops = step.numStops;
//        float distance = step.distance;
//        NSUInteger transitType = step.transitType;
//        NSString *startStation = step.startStation;
//        NSString *endStation =  step.endStation;
//        NSArray *path = step.path;
//    }
}

- (void)search:(MBSearch *)search didReceicedDriveDirections:(MBDriveDirections *)driveDirctions
{
//    NSUInteger numRoutes = driveDirctions.numRoutes;
//    NSArray *routes = driveDirctions.routes;
//    
//    MBDriveRoute *route = [routes objectAtIndex:0];
//    
//    MBCoordinateRegion region = route.region;
//    float distance = route.distance;
//    NSTimeInterval duration = route.duration;
//    NSString *instructions = route.instructions;
//    CLLocationCoordinate2D start = route.start;
//    CLLocationCoordinate2D end = route.end;
//    NSUInteger numSteps = route.numSteps;
//    NSArray *steps = route.steps;
//    
//    for (int i = 0; i< numSteps ; i++) {
//        MBDriveStep *step = [steps objectAtIndex:i];
//        
//        float distance = step.distance;
//        NSTimeInterval duration = step.duration;
//        NSString *instructions = step.instructions;
//        CLLocationCoordinate2D start = step.start;
//        CLLocationCoordinate2D end = step.end;
//        NSUInteger numPoints = step.numPoints;
//        NSArray *path = step.path;
//        
//        CLLocationCoordinate2D *coords = (CLLocationCoordinate2D *)malloc(sizeof(CLLocationCoordinate2D)*numPoints);
//        
//        for (int index = 0; index < numPoints; index++) {
//            NSInteger i = index * 2;
//            
//            coords[index] = (CLLocationCoordinate2D){[[path objectAtIndex:i + 1] intValue] / (double)100000, 
//                [[path objectAtIndex:i] intValue] / (double)100000};
//        }
//        MBPolyline *polyline = [MBPolyline polylineWithCoordinates:coords count:numPoints];
//        [_mapView addOverlay:polyline];
//        free(coords);
//
//        NSUInteger msgType = step.msgType;
//        NSUInteger turnType = step.turnType;
//        NSUInteger heading = step.heading;
//    }
}

- (void)search:(MBSearch *)search didReceicedWalkDirections:(MBDriveDirections *)driveDirctions
{
//    NSUInteger numRoutes = driveDirctions.numRoutes;
//    NSArray *routes = driveDirctions.routes;
//    
//    MBWalkRoute *route = [routes objectAtIndex:0];
//    
//    MBCoordinateRegion region = route.region;
//    float distance = route.distance;
//    NSTimeInterval duration = route.duration;
//    NSString *instructions = route.instructions;
//    CLLocationCoordinate2D start = route.start;
//    CLLocationCoordinate2D end = route.end;
//    NSUInteger numSteps = route.numSteps;
//    NSArray *steps = route.steps;
//    
//    for (int i = 0; i< numSteps ; i++) {
//        MBWalkStep *step = [steps objectAtIndex:i];
//        
//        float distance = step.distance;
//        NSTimeInterval duration = step.duration;
//        NSString *instructions = step.instructions;
//        CLLocationCoordinate2D start = step.start;
//        CLLocationCoordinate2D end = step.end;
//        NSUInteger numPoints = step.numPoints;
//        NSArray *path = step.path;
//    }
}

-(void)search:(MBSearch *)search didReceivedPoiResult:(MBPoiResult *)PoiResult
{
    [_mapView removeAnnotations:_mapView.annotations];
    [_results removeAllObjects];
    [_results setArray:PoiResult.resultList];
    MyCustomAnnotation *annotation;
    for (MBPoi *poi in _results)
    {
        annotation =  [[MyCustomAnnotation alloc]initWithLocation:poi.coordinate];
        annotation.title = poi.name;
        annotation.subtitle = poi.address;
        [_mapView addAnnotation:annotation];
        [annotation release];
    }
}
-(void)search:(MBSearch *)search didReceivedBusStationResult:(MBBusStationResult *)busStationResult
{
    [_mapView removeAnnotations:_mapView.annotations];
    [_results removeAllObjects];
    [_results setArray:busStationResult.resultList];
    MyCustomAnnotation *annotation;
    for (MBBusStation *station in _results)
    {
        annotation =  [[MyCustomAnnotation alloc]initWithLocation:station.coordinate];
        annotation.title = station.name;
        annotation.subtitle = station.address;
        [_mapView addAnnotation:annotation];
        [annotation release];
    }
}
-(void)search:(MBSearch *)search didReceivedBusLineResult:(MBBusLineResult *)busLineResult
{
    [_mapView removeAnnotations:_mapView.annotations];
    [_results removeAllObjects];
    [_results setArray:busLineResult.resultList];
    for (MBBusLine *line in _results)
    {
        NSLog(@"%@",[line name]);
    }
}
-(void)search:(MBSearch *)search didFailWithError:(NSError *)error
{
    [self.searchDisplayController.searchResultsTableView reloadData];
}


#pragma mark UISearchBarDelegate
- (void)searchBar:(UISearchBar *)searchBar textDidChange:(NSString *)searchText
{
    if (searchBar.tag == 100) 
    {
        [self getSuggestKeywords:searchText];
    }
    else  if(searchBar.tag == 101 || searchBar.tag == 102)
    {
        [self getRouteSuggest:searchText];
    }
}
- (void)searchBarSearchButtonClicked:(UISearchBar *)searchBar
{
    if (searchBar.tag == 100) {
        [self doSearch:searchBar.text];
        searchDisplayController0.active = NO;
    }
    else if(searchBar.tag == 101)
    {
        [destinationTextField resignFirstResponder];
        //searchDisplayController1.active = NO;
    }
    else if (searchBar.tag == 102) 
    {
        if (CLLocationCoordinate2DIsValid(origin) && CLLocationCoordinate2DIsValid(destination)) {
            [self searchDirectionsFromOrigin:origin toDestination:destination];
            searchDisplayController2.active = NO;
        }
    }
}
- (void)searchBar:(UISearchBar *)searchBar selectedScopeButtonIndexDidChange:(NSInteger)selectedScope
{
    
}
#pragma mark - UISearchDisplayControllerDelegate
- (void) searchDisplayControllerDidBeginSearch:(UISearchDisplayController *)controller
{
    UIControl *dismissControl = controller.searchContentsController.view.subviews.lastObject;
    dismissControl.frame = CGRectMake(0, 88, 320, 416);
}

- (void)searchDisplayController:(UISearchDisplayController *)controller willShowSearchResultsTableView:(UITableView *)tableView
{
     tableView.frame = CGRectMake(0, 88, 320, 416);
}
- (void)searchDisplayController:(UISearchDisplayController *)controller didShowSearchResultsTableView:(UITableView *)tableView
{
    tableView.frame = CGRectMake(0, 88, 320, 416);
}
- (BOOL)searchDisplayController:(UISearchDisplayController *)controller shouldReloadTableForSearchString:(NSString *)searchString
{
    return NO;
}

#pragma marl - MBMapViewDelegate

- (MBAnnotationView *)mapView:(MBMapView *)mapView viewForAnnotation:(id <MBAnnotation>)annotation
{
    if ([annotation isKindOfClass:[MyCustomAnnotation class]]) {
        MBAnnotationView* aView = [[[MBAnnotationView alloc] initWithAnnotation:annotation
                                                                reuseIdentifier:@"MyCustomAnnotation"] autorelease];
        aView.image = [UIImage imageNamed:@"poi.png"];
        return aView;
    }
    return nil;
}

-(MBOverlayView *)mapView:(MBMapView *)mapView viewForOverlay:(id<MBOverlay>)overlay
{
    if ([overlay isKindOfClass:[MBPolyline class]]) {
        MBPolylineView *polylineView = [[[MBPolylineView alloc] initWithPolyline:overlay] autorelease];
        polylineView.strokeColor = [UIColor purpleColor];
        return polylineView;
    }
    return nil;
}
@end
