//
//  MBDirctions.h
//  MBMapkit_library
//
//  Created by 张嘉伟 on 11-10-26.
//  Copyright 2011 Mapbar Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

/** @interface MBDirections
 *
 *  @brief
 *      MBDirections对象表示返回路线的结果列表
 *     
 */
@interface MBDirections : NSObject
{
@private
    NSDictionary *_internal;
    NSUInteger _numRoutes;
    NSArray *_routes;
}

/** @property   numRoutes
 *
 *  @brief  结果中可用的路线数目。
 *  @note   对于成功的查询，该数目应该是输入路标总数减 1。当没有可用结果时（因为未发布查询或先前的查询失败），此方法返回 0
 */
@property (nonatomic, readonly) NSUInteger numRoutes;

/** @property   routes
 *
 *  @brief  结果中可用的路线数目。
 *  @note   所有（ MBRoute 对象）路线的数组。
 */
@property (nonatomic ,readonly) NSArray *routes;

/** 
 *
 *  @brief 初始化MBDirections对象
 *  @param dictionary 包含MBDirections对象内容的数据字典
 *
 */
- (id)initWithDictionary:(NSDictionary *)dictionary;

@end
