//
//  MBPoiResult.h
//  MBMapkit_library
//
//  Created by 张嘉伟 on 11-10-26.
//  Copyright 2011 Mapbar Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreLocation/CoreLocation.h>

#import "MBListResult.h"

/** @interface MBPoiResult
 *
 *  @brief
 *      MBPoiResult对象表示搜索的结果
 *     
 */
@interface MBPoiResult : MBListResult

@end

/** @interface MBPoi
 *
 *  @brief
 *      MBPoi对象表示POI对象
 *     
 */
@interface MBPoi : NSObject
{
@private
    NSDictionary *_internal;
    NSString *_name;
    NSString *_type;
    NSString *_address;
    NSString *_phoneNumber;
    NSString *_detail;
    CLLocationCoordinate2D _coordinate;
    NSString *_searchString;
    double _distance;
    NSString *_orientation;
    float _rating;
    NSUInteger _numComments;
    NSString *_nid;
}
/** @property   name
 *
 *  @brief  名称
 */
@property (nonatomic, readonly) NSString *name;

/** @property   type
 *
 *  @brief  类型
 */
@property (nonatomic, readonly) NSString *type;

/** @property   address
 *
 *  @brief  地址
 */
@property (nonatomic, readonly) NSString *address;

/** @property   phoneNumber
 *
 *  @brief  电话号码
 */
@property (nonatomic, readonly) NSString *phoneNumber;

/** @property   detail
 *
 *  @brief  详细
 */
@property (nonatomic, readonly) NSString *detail;

/** @property   coordinate
 *
 *  @brief  加密经纬度字符串
 */
@property (nonatomic, readonly) CLLocationCoordinate2D coordinate;

/** @property   searchString
 *
 *  @brief  更多 //&tp=3&q=MAPBHVQACMTPYIZWLNX&ct=\U5317\U4eac\U5e02
 */
@property (nonatomic, readonly) NSString *searchString;

/** @property   distance
 *
 *  @brief  距离
 */
@property (nonatomic, readonly) double distance;

/** @property   orientation
 *
 *  @brief  方位
 */
@property (nonatomic, readonly) NSString *orientation;

/** @property   rating
 *
 *  @brief  评分 
 *  @note   满分五分
 */
@property (nonatomic, readonly) float rating;

/** @property   numComments
 *
 *  @brief  评论条数
 */
@property (nonatomic, readonly) NSUInteger numComments;

/** @property   nid
 *
 *  @brief  兴趣点的nid
 */
@property (nonatomic, readonly) NSString *nid;

/** 
 *
 *  @brief 初始化MBPoiResult对象
 *  @param dictionary 包含MBPoiResult对象内容的数据字典
 *
 */
-(id)initWithDictionary:(NSDictionary *)dictionary;

@end
