//
//  MBPointAnnotation.h
//  MBMapKit
//
//  Copyright 2011 Mapbar Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreLocation/CLLocation.h>

#import "MBShape.h"

/** @interface MBPointAnnotation
 *
 *  @brief
 *      MBPointAnnotation类定义了一个位于指定点的具体标注对象。当你只需要在地图中添加一个带标题的点时，你可以使用本类而不
 *      需要自己定义。
 */
@interface MBPointAnnotation : MBShape{
@package 
    CLLocationCoordinate2D _coordinate;
}
/** @property   coordinate
 *
 *  @brief  标注的坐标点，由经度和维度定义。
 */
@property (nonatomic, assign) CLLocationCoordinate2D coordinate;

@end
