//
//  MBRouteSuggestResult.h
//  MBMapkit_library
//
//  Created by 张嘉伟 on 11-10-26.
//  Copyright 2011 Mapbar Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreLocation/CoreLocation.h>

/** @interface MBRouteSuggestResult
 *
 *  @brief
 *      MBRouteSuggestResult对象表示路线建议关键词的结果
 *     
 */
@interface MBRouteSuggestResult : NSObject
{
@private
    NSDictionary *_internal;
    NSUInteger _count;
    NSArray *_suggests;
}
/** @property   count
 *
 *  @brief  路线建议关键词的数量
 */
@property (nonatomic, readonly) NSUInteger count;

/** @property   suggests
 *
 *  @brief  所有（MBRouteSuggest 对象）的数组
 */
@property (nonatomic, readonly) NSArray *suggests;

/** 
 *
 *  @brief 初始化MBRouteSuggestResult对象
 *  @param dictionary 包含MBRouteSuggestResult对象内容的数据字典
 *
 */
- (id)initWithDictionary:(NSDictionary *)dictionary;

@end

/** @interface MBRouteSuggest
 *
 *  @brief
 *      MBSuggest对象表示路线建议关键词。
 *     
 */
@interface MBRouteSuggest : NSObject
{
@private
    NSDictionary *_internal;
    NSString *_address;
    CLLocationCoordinate2D _coordinate;
    double _distance;
    NSString *_searchString;
    NSString *_name;
    NSString *_orientation;
    BOOL _isStation;
    NSString *_type;
}
/** @property   address
 *
 *  @brief  地址
 */
@property (nonatomic, readonly) NSString *address;

/** @property   coordinate
 *
 *  @brief  加密经纬度字符串
 */
@property (nonatomic, readonly) CLLocationCoordinate2D coordinate;

/** @property   distance
 *
 *  @brief  距离相对搜索中心
 */
@property (nonatomic, readonly) double distance;

/** @property   searchString
 *
 *  @brief  更多 //&tp=3&q=MAPBHVQACMTPYIZWLNX&ct=\U5317\U4eac\U5e02
 */
@property (nonatomic, readonly) NSString *searchString;

/** @property   name
 *
 *  @brief  名称
 */
@property (nonatomic, readonly) NSString *name;

/** @property   orientation
 *
 *  @brief  方向
 */
@property (nonatomic, readonly) NSString *orientation;

/** @property   isStation
 *
 *  @brief  是否为车站
 */
@property (nonatomic, readonly) BOOL isStation;

/** @property   type
 *
 *  @brief  类型
 */
@property (nonatomic, readonly) NSString *type;

/** 
 *
 *  @brief 初始化MBRouteSuggest对象
 *  @param dictionary 包含MBRouteSuggest对象内容的数据字典
 *
 */
- (id)initWithDictionary:(NSDictionary *)dictionary;

@end
