//
//  MBShape.h
//  MBMapKit
//
//  Copyright 2011 Mapbar Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MBAnnotation.h"

/** @interface MBShape
 *
 *  @brief
 *      MBShape 类是一个抽象类，定义了所有基于形状的标注对象的基本属性。本类必须子类化不能直接使用。子类负责定义形状的几何信
 *      息，还要提供继承自 MBAnnotation 协议的坐标属性。
 */
@interface MBShape : NSObject <MBAnnotation> 
{
@package
    NSString *_title;
    NSString *_subtitle;
}

/**
 *
 *  @brief  形状标注的标题。
 *  @note   
 *      本字符串显示在关联标注视图弹出气泡中。本属性的默认值为nil。
 */
@property (copy) NSString *title;

/**
 *
 *  @brief  形状标注的副标题。
 *  @note   
 *      本字符串显示在关联标注视图弹出气泡中。本属性的默认值为nil。
 */
@property (copy) NSString *subtitle;

@end
