//
//  MBSuggestResult.h
//  MBMapkit_library
//
//  Created by 张嘉伟 on 11-10-26.
//  Copyright 2011 Mapbar Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

/** @interface MBSuggestResult
 *
 *  @brief
 *      MBSuggestResult对象表示建议关键词的结果
 *     
 */
@interface MBSuggestResult : NSObject
{
@private
    NSDictionary *_internal;
    NSUInteger _count;
    NSArray *_suggests;
}
/** @property   count
 *
 *  @brief  建议关键词的数量
 */
@property (nonatomic, readonly) NSUInteger count;

/** @property   suggests
 *
 *  @brief  所有（MBSuggest对象）的数组
 */
@property (nonatomic ,readonly) NSArray *suggests;

/** 
 *
 *  @brief 初始化MBSuggestResult对象
 *  @param dictionary 包含MBSuggestResult对象内容的数据字典
 *
 */
- (id)initWithDictionary:(NSDictionary *)dictionary;

@end

/** @interface MBSuggest
 *
 *  @brief
 *      MBSuggest对象表示建议关键词。
 *     
 */
@interface MBSuggest : NSObject
{
@private
    NSDictionary *_internal;
    NSUInteger _index;
    NSString *_city;
    NSString *_district;
    NSString *_keyword;
}

/** @property   index
 *
 *  @brief  当前建议关键词的索引
 */
@property (nonatomic, readonly) NSUInteger index;

/** @property   city
 *
 *  @brief  关键字对应城市
 */
@property (nonatomic, readonly) NSString *city;

/** @property   district
 *
 *  @brief  关键字对应区域
 */
@property (nonatomic, readonly) NSString *district;

/** @property   keyword
 *
 *  @brief  建议关键词
 */
@property (nonatomic, readonly) NSString *keyword;

/** 
 *
 *  @brief 初始化MBSuggest对象
 *  @param dictionary 包含MBSuggest对象内容的数据字典
 *
 */
- (id)initWithDictionary:(NSDictionary *)dictionary;

@end
