//
//  MBWalkDirections.h
//  MBMapkit_library
//
//  Created by 张嘉伟 on 11-10-26.
//  Copyright 2011 Mapbar Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "MBDirections.h"
#import "MBRoute.h"
#import "MBStep.h"

/** @interface MBDirections
 *
 *  @brief
 *      MBDirections对象表示返回步行路线的结果列表
 *     
 */
@interface MBWalkDirections : MBDirections

@end

/** @interface MBRoute
 *
 *  @brief
 *      MBRoute对象表示步行路线结果中存储单条路线的信息
 *     
 */
@interface MBWalkRoute : MBRoute

@end

/** @interface MBStep
 *
 *  @brief
 *      MBStep对象表示步行路线结果中存储一条路线中单个路段的信息
 *     
 */
@interface MBWalkStep : MBStep {
@private
    NSUInteger _turnType;
    NSUInteger _heading;
}
/** @property   turnType
 *
 *  @brief  包含此路段的转弯类型。
 */
@property (nonatomic, readonly) NSUInteger turnType;

/** @property   heading
 *
 *  @brief  包含此路段的朝向。
 */
@property (nonatomic, readonly) NSUInteger heading;

/** 
 *
 *  @brief 初始化MBWalkStep对象
 *  @param dictionary 包含MBWalkStep对象内容的数据字典
 *
 */
- (id)initWithDictionary:(NSDictionary *)dictionary;

@end